
# line 15 "arc.y"
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>
#include "cdefs.h"
#include "types.h"
#include "symbols.h"
#include "error.h"

#define YYSTYPE YYMYTYPE	/* get around bug in yacc .... */

# define ANSWER_BUFF_SIZE 100

typedef struct mystype {
	int count;
	GTYPE g;
	} YYMYTYPE;

extern GTYPE valueStack[];
#define pushValueStack(g)	if (push_value_stack(g) == -1) YYERROR;
#define popValueStack(i)	if (pop_value_stack(i) == -1) YYERROR;

int answerIndex = 0;
int lastIndex = 0;

extern matrix fullrange;
matrix fullrange = { -1, -1, 0 };
#define FULLRANGE (&fullrange)

char combuf[1024];

#ifndef X86Linux_TARGET
extern char *strcpy();
#endif

char *grepcopy (s1, s2)
char *s1, *s2;
{
	int c;

	while (c = *s2++)
	 { if (isdigit(c) || isalpha(c) || c == '_')
	    { *s1++ = c;
	    }
	   else
	    { *s1++ = '\\';
	      *s1++ = c;
	    }
	 }
 	*s1 = '\0';
}

static errorPoint = UNDEF;

yyerror (s)
char *s;
{
	errorPoint = getInputColumn();
}

char *helpFileName();

# define DBLE 257
# define STR 258
# define ERR 259
# define ENTER 260
# define INT 261
# define IDENTIFIER 262
# define INDEX 263
# define HELP 264
# define KEY 265
# define CVTOCT 266
# define CVTHEX 267
# define CVTDEC 268
# define CVTBIN 269
# define CONVERT 270
# define UMINUS 271
# define UPLUS 272

#include <inttypes.h>

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
#ifndef yyerror
#if defined(__cplusplus)
	void yyerror(const char *);
#endif
#endif
#ifndef yylex
	int yylex(void);
#endif
	int yyparse(void);
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#endif

#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 520 "arc.y"


#include "cdefs.h"

main (argc, argv)
int argc;
char **argv;
{
	int function, i;

	argc--; argv++;
	while (argc)
	 { if (ARGUMENT ("-i"))
	    { int base;
	      argc--; argv++;
	      if (sscanf (*argv, "%d", &base) != 1 ||
		  base < 2 || base > 16)
	       { fprintf (stderr, 
		 "ERROR: -i option requires an integer 2 to 16\n");
		 exit (-1);
	       }
	      setInputBase (base);
	    }
	   else if (ARGUMENT ("-o"))
	    { int base;
	      argc--; argv++;
	      if (sscanf (*argv, "%d", &base) != 1 ||
		  base < 2 || base > 16)
	       { fprintf (stderr, 
		 "ERROR: -o option requires an integer 2 to 16\n");
		 exit (-1);
	       }
	      setOutputBase (base);
	    }
	   else
	    { fprintf (stderr, "USAGE: arc [-i <base>] [-o base]\n");
	      exit (-1);
	    }
	   argc--; argv++;
	 }

	initSymbolTable();  /* initialize constants */
	setInputColumn (printPrompt (answerIndex));
	yyparse ();
}

# include "lex.yy.c"
static const yytabelem yyexca[] ={
-1, 1,
	0, -1,
	257, 12,
	258, 12,
	261, 12,
	262, 12,
	43, 12,
	45, 12,
	40, 12,
	60, 12,
	-2, 0,
	};
# define YYNPROD 51
# define YYLAST 243
static const yytabelem yyact[]={

     5,    84,    12,    76,     4,    10,    68,     9,     6,    66,
    12,    72,    23,    10,     7,     9,    24,    48,    19,    32,
    47,    33,    14,    42,    28,    26,    33,    27,    33,    29,
    14,    23,    62,    20,    32,    24,    33,    46,    22,    28,
    26,     8,    27,    63,    29,    74,    37,    35,    36,    37,
    39,    32,    70,    33,    70,    86,    28,    26,    45,    27,
    41,    29,    70,    87,    50,    51,    52,    53,    54,    55,
    56,    11,    71,    34,    30,    58,    31,    90,    34,    64,
    79,    31,    78,    31,    40,    79,    67,    44,    34,    30,
    32,    31,    33,    15,    61,    28,    26,    32,    27,    33,
    29,    80,    28,    73,    21,    34,    30,    29,    31,    83,
    32,    42,    33,    43,    38,    28,    26,    85,    27,     3,
    29,     2,    57,    59,    88,    64,    60,    49,     1,    82,
    65,    89,    75,     0,    77,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    34,    30,     0,    31,     0,     0,
     0,    34,    30,     0,    31,    81,     0,     0,     0,     0,
     0,     0,     0,     0,    34,    30,     0,    31,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    69,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
    18,     0,     0,    17,    13,     0,     0,    16,    18,     0,
     0,    17,    13,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    25 };
static const yytabelem yypact[]={

-10000000,  -256,-10000000,   -30,-10000000,  -242,  -227,-10000000,   -18,   -30,
   -30,   -15,   -30,    20,   -38,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,  -243,  -246,-10000000,-10000000,-10000000,   -30,   -30,   -30,   -30,
   -30,   -30,   -30,-10000000,   -38,   -13,   -13,   -30,    82,    53,
   -12,   -30,   -38,   -53,    18,-10000000,    14,-10000000,-10000000,  -249,
    60,    60,   -13,   -13,   -13,   -11,   -13,    10,    73,   -16,
  -259,-10000000,  -259,    41,    73,     8,-10000000,   -38,-10000000,-10000000,
   -38,   -30,-10000000,-10000000,  -261,-10000000,   -68,-10000000,-10000000,   -30,
-10000000,    18,-10000000,    -3,    23,    73,   -30,   -30,    73,    36,
-10000000 };
static const yytabelem yypgo[]={

     0,   128,   121,   119,    37,   104,    71,   114,    43,    87,
   113,    93,    86,    58 };
static const yytabelem yyr1[]={

     0,     1,     1,     2,     2,     2,     2,     2,     2,     5,
     5,     3,     3,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     7,     7,     6,     6,    11,    11,    11,    11,     8,     8,
     8,    10,    10,    12,    12,     9,     9,    13,    13,    13,
    13 };
static const yytabelem yyr2[]={

     0,     0,     4,     7,     3,     5,     5,     7,     9,     3,
     3,     3,     1,     7,     7,     7,     7,     7,     7,     7,
     5,     5,     5,     7,    17,     9,     9,     7,     3,     7,
     7,     7,     3,     9,     3,     3,     3,     3,     1,     3,
     7,     3,     7,     2,     2,     3,     7,     3,     3,     7,
    11 };
static const yytabelem yychk[]={

-10000000,    -1,    -2,    -3,   260,   256,   264,   270,    -4,    45,
    43,    -6,    40,   262,    60,   -11,   257,   261,   258,   260,
   260,    -5,   265,   258,   262,   260,    43,    45,    42,    47,
    92,    94,    37,    39,    91,    -4,    -4,    61,    -7,    -4,
    -6,    40,    91,   -10,    -9,   -13,    -4,    58,   260,    -5,
    -4,    -4,    -4,    -4,    -4,    -4,    -4,    -9,    -4,    41,
    44,    41,    44,    -8,    -4,    -9,    62,   -12,    59,   260,
    44,    58,   260,    93,    61,    -6,   262,    -6,    41,    44,
    93,    -9,   -13,    -4,   262,    -4,    58,    40,    -4,    -8,
    41 };
static const yytabelem yydef[]={

     1,    -2,     2,     0,     4,     0,     0,    11,     0,     0,
     0,    37,     0,    32,     0,    28,    34,    35,    36,     5,
     6,     0,     0,     9,    10,     3,     0,     0,     0,     0,
     0,     0,     0,    22,     0,    20,    21,     0,     0,     0,
    37,    38,     0,     0,    41,    45,    47,    48,     7,     0,
    13,    14,    15,    16,    17,    18,    19,     0,    23,     0,
     0,    29,     0,     0,    39,     0,    27,     0,    43,    44,
     0,     0,     8,    26,     0,    31,    32,    30,    25,     0,
    33,    42,    46,    49,     0,    40,     0,    38,    50,     0,
    24 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"DBLE",	257,
	"STR",	258,
	"ERR",	259,
	"ENTER",	260,
	"INT",	261,
	"IDENTIFIER",	262,
	"INDEX",	263,
	"HELP",	264,
	"KEY",	265,
	"CVTOCT",	266,
	"CVTHEX",	267,
	"CVTDEC",	268,
	"CVTBIN",	269,
	"CONVERT",	270,
	"=",	61,
	"+",	43,
	"-",	45,
	"*",	42,
	"/",	47,
	"%",	37,
	"\\",	92,
	"UMINUS",	271,
	"UPLUS",	272,
	"[",	91,
	"^",	94,
	"\'",	39,
	"(",	40,
	")",	41,
	"$",	36,
	",",	44,
	";",	59,
	"<",	60,
	">",	62,
	".",	46,
	"]",	93,
	":",	58,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"session : /* empty */",
	"session : session statement",
	"statement : convert expr ENTER",
	"statement : ENTER",
	"statement : error ENTER",
	"statement : HELP ENTER",
	"statement : HELP keyword ENTER",
	"statement : HELP KEY keyword ENTER",
	"keyword : STR",
	"keyword : IDENTIFIER",
	"convert : CONVERT",
	"convert : /* empty */",
	"expr : expr '+' expr",
	"expr : expr '-' expr",
	"expr : expr '*' expr",
	"expr : expr '/' expr",
	"expr : expr '\\' expr",
	"expr : expr '^' expr",
	"expr : expr '%' expr",
	"expr : '-' expr",
	"expr : '+' expr",
	"expr : expr '\''",
	"expr : symbol '=' expr",
	"expr : '(' symbol.list ')' '=' IDENTIFIER '(' expr.list ')'",
	"expr : IDENTIFIER '(' expr.list ')'",
	"expr : expr '[' elements.list ']'",
	"expr : '<' matrix '>'",
	"expr : primary",
	"expr : '(' expr ')'",
	"symbol.list : symbol ',' symbol",
	"symbol.list : symbol.list ',' symbol",
	"symbol : IDENTIFIER",
	"symbol : IDENTIFIER '[' elements.list ']'",
	"primary : DBLE",
	"primary : INT",
	"primary : STR",
	"primary : symbol",
	"expr.list : /* empty */",
	"expr.list : expr",
	"expr.list : expr.list ',' expr",
	"matrix : elements.list",
	"matrix : matrix rowdelimiter elements.list",
	"rowdelimiter : ';'",
	"rowdelimiter : ENTER",
	"elements.list : elements",
	"elements.list : elements.list ',' elements",
	"elements : expr",
	"elements : ':'",
	"elements : expr ':' expr",
	"elements : expr ':' expr ':' expr",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.15	97/12/08 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			long yyps_index = (yy_ps - yys);
			long yypv_index = (yy_pv - yyv);
			long yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register const int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 3:
# line 97 "arc.y"
{ SYMBOL_TABLE_ENTRY *entry;
		   char aname[8];

		   printValue (&(yypvt[-1].g), answerIndex, yypvt[-2].count);

		   /* ---- store results in answer buffer  ---- */

		   sprintf (aname, "$%d", answerIndex);
		   if ((entry = locateSymbol (aname)) == NULL)
		    { if ((entry = insertSymbol (aname)) == NULL)
		       { putOut ('\n'); 
		   	 print_errors();
			 clear_errors();
			 putOut ('\n');
		       }
		      else
		       { entry->protection = 0;
		       }
		    }
		   else
		    { free_gtype (&entry->g);
		    }
		   if (entry)
		    { if (mcopy_gtype (&entry->g, &(yypvt[-1].g)) == NULL)
		       { putOut ('\n'); 
		   	 print_errors();
			 clear_errors();
			 putOut ('\n');
		       }
		      else
		       { lastIndex = answerIndex;
		         answerIndex = ++answerIndex % ANSWER_BUFF_SIZE;
		       }
		    }
		   talloc_reset();
		   clearValueStack();

		   setInputColumn (printPrompt (answerIndex));
		 } break;
case 4:
# line 137 "arc.y"
{ setInputColumn (printPrompt (answerIndex));
		 } break;
case 5:
# line 140 "arc.y"
{ 
		   talloc_reset();
		   clearValueStack();
		   yyerrok;
		   if (num_errors())
		    { putOut ('\n');
		      print_errors();
		      clear_errors();
		      putOut ('\n');
		    }
		   else
		    { int j;

		      if (errorPoint == UNDEF)
		       { putOut ('\n');
			 printOut ("ughhh! ... syntax error\n");
			 putOut ('\n');
		       }
		      else
		       { char *msg = " syntax error ";
			 if (errorPoint >= strlen (msg))
			  { for (j=0; j<errorPoint-strlen(msg); j++)
		             { putOut (' ');
		             }
		            printOut ("%s^\n\n", msg);
			  }
			 else
			  { for (j=0; j<errorPoint; j++)
			     { putOut (' ');
			     }
			    printOut ("^%s\n\n", msg);
			  }
			 errorPoint = UNDEF;
		       }
		    }
		   setInputColumn (printPrompt (answerIndex));
		 } break;
case 6:
# line 178 "arc.y"
{
		   char *helpfile;
		   if ((helpfile = helpFileName()) != NULL)
		    { printOut ("\n Accessing help file ...\n\n");
		      sprintf (combuf, "less %s", helpfile);
		      system (combuf);
		      putOut ('\n');
		    }
		   setInputColumn (printPrompt (answerIndex));
		 } break;
case 7:
# line 189 "arc.y"
{ char *s;
		   char *helpfile;
		   if ((helpfile = helpFileName()) != NULL)
		    { grepcopy(combuf, yypvt[-1].g.name);
		      s = strcpy ((char *)talloc(strlen(combuf)+1), combuf);
   
		      printOut ("\n Checking help file ...\n\n");
		      sprintf(combuf,"egrep -s '\t.*(%s|e1 %s).*---' %s",
			      s, s, helpfile);
		      if (system(combuf) != 0)
		       { printOut (" nothing appropriate\n");
		       }
		      else
		       { sprintf(combuf,
			 "less '+/\t.*%s.*---' %s",s, helpfile);
			 system (combuf);
		       }
		      putOut ('\n');
		      talloc_reset();
   		    }
		   setInputColumn (printPrompt (answerIndex));
		 } break;
case 8:
# line 212 "arc.y"
{ char *s;
		   char *helpfile;

		   if ((helpfile = helpFileName()) != NULL)
		    { grepcopy(combuf, yypvt[-1].g.name);
		      s = strcpy ((char *)talloc(strlen(combuf)+1), combuf);
   
		      printOut ("\n Checking help file ...\n\n");
		      sprintf (combuf, "egrep '(---.*%s|%s.*---)' %s", 
			       s, s, helpfile);
		      if (system (combuf) != 0)
		       { printOut (" nothing appropriate\n\n");
		       }
		      putOut ('\n');
		      talloc_reset();
		    }
		   setInputColumn (printPrompt (answerIndex));
		 } break;
case 9:
# line 232 "arc.y"
{ yyval.g.name = yypvt[-0].g.val.s;
		  } break;
case 10:
# line 235 "arc.y"
{ yyval.g.name = yypvt[-0].g.name;
		  } break;
case 11:
# line 239 "arc.y"
{ yyval.count = yypvt[-0].count;
		  } break;
case 12:
# line 242 "arc.y"
{ yyval.count = 0;
		  } break;
case 13:
# line 246 "arc.y"
{ if (binop (&(yyval.g), "+", &(yypvt[-2].g), &(yypvt[-0].g)) == NULL)
		    { YYERROR;
		    }
		 } break;
case 14:
# line 251 "arc.y"
{ if (binop (&(yyval.g), "-", &(yypvt[-2].g), &(yypvt[-0].g)) == NULL)
		    { YYERROR;
		    }
		 } break;
case 15:
# line 256 "arc.y"
{ if (binop (&(yyval.g), "*", &(yypvt[-2].g), &(yypvt[-0].g)) == NULL)
		    { YYERROR;
		    }
		 } break;
case 16:
# line 261 "arc.y"
{ if (binop (&(yyval.g), "/", &(yypvt[-2].g), &(yypvt[-0].g)) == NULL)
		    { YYERROR;
		    }
		 } break;
case 17:
# line 266 "arc.y"
{ if (binop (&(yyval.g), "\\", &(yypvt[-2].g), &(yypvt[-0].g)) == NULL)
		    { YYERROR;
		    }
		 } break;
case 18:
# line 271 "arc.y"
{ if (binop (&(yyval.g), "^", &(yypvt[-2].g), &(yypvt[-0].g)) == NULL)
		    { YYERROR;
		    }
		 } break;
case 19:
# line 276 "arc.y"
{ if (binop (&(yyval.g), "%", &(yypvt[-2].g), &(yypvt[-0].g)) == NULL)
		    { YYERROR;
		    }
		 } break;
case 20:
# line 281 "arc.y"
{ if (monop (&(yyval.g), "-", &(yypvt[-0].g)) == NULL)
		    { YYERROR;
		    }
		 } break;
case 21:
# line 286 "arc.y"
{ yyval.g = yypvt[-0].g;
		   yyval.g.name = NULL;
		 } break;
case 22:
# line 290 "arc.y"
{ if (monop (&(yyval.g), "'", &(yypvt[-1].g)) == NULL)
		    { YYERROR;
		    }
		 } break;
case 23:
# line 295 "arc.y"
{ GTYPE g;

		   if (assignValue (&g, &yypvt[-2].g, &yypvt[-0].g) == NULL)
		    { YYERROR;
		    }
		   yyval.g = g;
		 } break;
case 24:
# line 303 "arc.y"
{ GTYPE g;
		   int vi, si, ri, i;

		   vi = valueStackIndex() - yypvt[-1].count;
		   si = vi - yypvt[-6].count;
		   ri = valueStackIndex();

		   for (i=0; i<yypvt[-6].count; i++)
		    { pushValueStack(g);	/* space for return values */
		    }
		   valueStack[ri].val.i = yypvt[-6].count;
		   valueStack[ri].name  = yypvt[-3].g.name;
		   if (function (&valueStack[ri], yypvt[-1].count,
				 &valueStack[vi]) == -1)
		    { YYERROR;
		    }
		   for (i=yypvt[-6].count-1; i>=0; i--)
		    { if (assignValue (&g, &valueStack[si+i],
					   &valueStack[ri+i]) == NULL)
		       { YYERROR;
		       }
		    }
		   popValueStack (yypvt[-1].count + yypvt[-6].count);
		   yyval.g = g;
		 } break;
case 25:
# line 329 "arc.y"
{ GTYPE g;
		   int vi = valueStackIndex() - yypvt[-1].count;

		   g.val.i = 1;
		   g.name  = yypvt[-3].g.name;
		   if (function (&g, yypvt[-1].count,
		   	         &valueStack[vi]) == -1)
		    { YYERROR;
		    }
		   yyval.g = g;
		   yyval.g.name = NULL;
		   popValueStack (yypvt[-1].count);
		 } break;
case 26:
# line 343 "arc.y"
{ GTYPE g;
		   matrix *row_i, *col_i;

		   if (buildSubscriptMatrices(&row_i, &col_i, yypvt[-1].count) 
		       == -1)
		    { YYERROR;
		    }
		   if (subscriptValue (&g, &yypvt[-3].g, row_i, col_i) == NULL)
		    { YYERROR;
		    }
		   yyval.g = g;
		 } break;
case 27:
# line 356 "arc.y"
{ GTYPE g;

		   if (buildMatrix (&g, yypvt[-1].count) == NULL)
		    { YYERROR;
		    }
		   yyval.g = g;
		 } break;
case 28:
# line 364 "arc.y"
{ yyval.g = yypvt[-0].g;
		 } break;
case 29:
# line 367 "arc.y"
{ yyval.g = yypvt[-1].g;
		 } break;
case 30:
# line 371 "arc.y"
{ yyval.count = 2;

		   pushValueStack (yypvt[-2].g);
		   pushValueStack (yypvt[-0].g);
		 } break;
case 31:
# line 377 "arc.y"
{ yyval.count = yypvt[-2].count + 1;

		   pushValueStack (yypvt[-0].g);
		 } break;
case 32:
# line 383 "arc.y"
{
		   yyval.g.name = yypvt[-0].g.name;
		   yyval.g.row_i = NULL;
		   yyval.g.col_i = NULL;
		 } break;
case 33:
# line 389 "arc.y"
{ GTYPE g;

		   g.name = yypvt[-3].g.name;
		   if (buildSubscriptMatrices(&g.row_i, &g.col_i, yypvt[-1].count) 
		       == -1)
		    { YYERROR;
		    }
		   yyval.g = g;
		 } break;
case 34:
# line 400 "arc.y"
{ yyval.g = yypvt[-0].g;
		 } break;
case 35:
# line 403 "arc.y"
{ yyval.g = yypvt[-0].g;
		 } break;
case 36:
# line 406 "arc.y"
{ yyval.g = yypvt[-0].g;
		 } break;
case 37:
# line 409 "arc.y"
{ GTYPE gs, gr;
		   SYMBOL_TABLE_ENTRY *entry;
		   char *idname, aname[8];

		   if (strcmp (yypvt[-0].g.name, "$") == 0)
		    { sprintf (aname, "$%d", lastIndex);
		      idname = aname;
		    }
		   else
		    { idname = yypvt[-0].g.name;
		    }
		   if ((entry = locateSymbol (idname)) == NULL)
		    { error (0, "symbol %s is not defined\n", yypvt[-0].g.name);
		      YYERROR;
		    }
		   if (tcopy_gtype (&gs, &entry->g) == NULL)
		    { YYERROR;
		    }
		   if (subscriptValue (&gr, &gs, yypvt[-0].g.row_i, yypvt[-0].g.col_i)
		   	== NULL)
		    { YYERROR;
		    }
		   yyval.g.type  = gr.type;
		   yyval.g.val   = gr.val;

		   yyval.g.name  = yypvt[-0].g.name;
		   yyval.g.row_i = yypvt[-0].g.row_i;
		   yyval.g.col_i = yypvt[-0].g.col_i;
		 } break;
case 38:
# line 440 "arc.y"
{ yyval.count = 0;
		 } break;
case 39:
# line 443 "arc.y"
{ pushValueStack (yypvt[-0].g);
		   yyval.count = 1;
		 } break;
case 40:
# line 447 "arc.y"
{ pushValueStack (yypvt[-0].g);
		   yyval.count = yypvt[-2].count + 1;
		 } break;
case 41:
# line 452 "arc.y"
{ GTYPE g;

		   if (buildMatrixRow (&g, yypvt[-0].count) == NULL)
		    { YYERROR;
		    }
		   pushValueStack (g);
		   yyval.g = g;		/* for row/column comparison */
		   yyval.count = 1;
		 } break;
case 42:
# line 462 "arc.y"
{ GTYPE g;

		   if (buildMatrixRow(&g, yypvt[-0].count) == NULL)
		    { YYERROR;
		    }
		   if ((g.val.m->row != yypvt[-2].g.val.m->row) ||
		       (g.val.m->col != yypvt[-2].g.val.m->col))
		    { error (0, "build matrix -- row/column mismatch\n");
		      YYERROR;
		    }
		   pushValueStack (g);
		   yyval.g = g;		/* for row/column comparison */
		   yyval.count = yypvt[-2].count + 1;
		 } break;
case 45:
# line 481 "arc.y"
{ yyval.count = 1;
		 } break;
case 46:
# line 484 "arc.y"
{ yyval.count = yypvt[-2].count + 1;
		 } break;
case 47:
# line 488 "arc.y"
{ 
		   pushValueStack (yypvt[-0].g);
		 } break;
case 48:
# line 492 "arc.y"
{ GTYPE g;

		   g.val.m = FULLRANGE;
		   g.type = MATRIX;
		
		   g.name =  NULL;
		   g.row_i = NULL;
		   g.col_i = NULL;

		   pushValueStack (g);
		 } break;
case 49:
# line 504 "arc.y"
{ GTYPE g;

		   if (buildRangeMatrix	(&g, &yypvt[-2].g, &yypvt[-0].g, NULL) == NULL)
		    { YYERROR;
		    }
		   pushValueStack (g);
		 } break;
case 50:
# line 512 "arc.y"
{ GTYPE g;

		   if (buildRangeMatrix (&g, &yypvt[-4].g, &yypvt[-2].g, &yypvt[-0].g) == NULL)
		    { YYERROR;
		    }
		   pushValueStack (g);
		 } break;
# line	531 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

