#include <rccl.h>
#include "manex.260.h"

#ifdef VXWORKS_CFG
#define main simple_260_
#endif

main()
{
  TRSF_PTR t, r;
  POS_PTR pos;
  MANIP *mnp;
  JNTS rcclpark;
  char *robotName;

  rcclSetOptions (RCCL_ERROR_EXIT);

  robotName = "blue";
  printf("using robot '%s'\n", robotName);
  if (!getRobotPosition (rcclpark.v, "rcclpark", robotName)) {
    printf ("position 'rcclpark' not defined for robot\n");
    exit(-1);
  }

  t = allocTransXyz ("T", UNDEF, P_X - 200.0, P_Y, P_Z);
  r = allocTransRot ("R", UNDEF, 0.0, 0.0, 0.0, xunit, 180.0);
/*  multTrsfRpy (r, 180.0, 0.0, 0.0); */
  pos = makePosition ("pos", T6, EQ, t, r, NULL);

  rcclSetOptions (RCCL_SIMULATE);

  mnp = rcclCreate (robotName, 0);
  rcclStart();

  movej (mnp, &rcclpark);

/*setMod (mnp, 'c');*/
  move (mnp, pos);
#if 0
  waitForCompleted (mnp);
#endif
  stop (mnp, 1000.0);

  movej (mnp, &rcclpark);
  stop (mnp, 1000.0);

  waitForCompleted (mnp);
  rcclRelease (YES);
}
