#include "../h/cdefs.h"
#include "../h/robotMath.h"
#include "../h/robot_jls.h"
#include "../h/fatalMsg.h"

float ang[MAXJNTS];
int enc[MAXJNTS];

#if Vxw_TARGET
#define main enctoangDemo_
#endif

char **argvec;

main(argc, argv)
int argc;
char *argv[];
{
	int j;
	JLS *jls;

	argvec = argv;
	argc--; argv++;
	if (argc != 1)
	 { usageMsg (-1, "%s <robot-name>\n", argvec[0]);
	 }
	
	if ((jls = getJls (*argv)) == NULL)
	 { printErrors();
	   exit (-1);
	 }
	while (1)
	 { for (j=0; j<jls->numJ; j++)
	    { if (scanf ("%d", &enc[j]) != 1)
	       { exit (0);
	       }
	    }
	   encoderToJoint (ang, enc, jls);
	   radianToDegree (ang, ang, jls);
	   for (j=0; j<jls->numJ; j++)
	    { printf ("%8.3f ", ang[j]);
	    }
	   putchar ('\n');
	 }
}

