#ifndef _PANTILT_H_WRAP_
#define _PANTILT_H_WRAP_

#define PANTILT_REP_BUFSIZE 256

typedef struct {
	char buf[PANTILT_REP_BUFSIZE];
	char *bp;
	int cnt;
} PanTiltReply;

int panTiltOpen (char *name);
void panTiltClose (int fd);
int panTiltSetPos (int fd, int *new, int *old, double interval);
int panTiltSetPosAsync (int fd, int *new, int *old, double interval);
int panTiltSetPosReply (int fd, PanTiltReply *rep);
int panTiltSetComSet (int fd, int comset);
int panTiltSetCoordinates (int fd, int coords);
int panTiltGetCoordinates (int fd, int* coords);
int panTiltSetAddress (int fd, int coords);
int panTiltGetPos (int fd, int *pos);
int panTiltGetPosAsync (int fd);
int panTiltGetPosReply (int fd, int *pos, PanTiltReply *rep);
int panTiltSetBaud (int fd, int baud);
int panTiltCheckBaud (int fd);
int panTiltCalibrate (int fd);
int panTiltVerifyPos(int fd, int mode);
int panTiltGetReferPos(int fd, int* AziExtA, int* EleExtA, int* AziRefA,
	int* EleRefA, int* AziRefB, int* EleRefB, int* AziExtB, int* EleExtB);
int panTiltStop(int fd);
int panTiltGetBaseCfg (int fd, int *info);
int panTiltSetBaseCfg (int fd, int maxrate, int startrate,
			       int accel, int powerTimeOut);
int panTiltGetHeadCfg (int fd, int *info);
int panTiltSetHeadCfg (int fd, int maxrate, int startrate,
			       int accel, int powerTimeOut);

#endif
