/* 
 * pid.h -- 
 * 
 * Stewart Kingdon,
 * Copyright (c) 1998,
 * Laboratory for Computational Intelligence,
 * University of British Columbia.
 */

/*
 * $Author$
 * $Date$
 * $Revision$
 *
 * $Log$
 */

/* $Id$ */

#ifndef _PID_H_
#define _PID_H_

typedef struct
{
      int       mode;		/* 0 = stop */
      int       goal;
      int       posn;
      int       kp;
      int       kd;
      int       ki;
      int       imax;
      int       ival;
} PID;

typedef struct
{
      unsigned  magic;		/* should be 0xCAFEBABE */
      unsigned  version;	/* should be 0x00000001 */
      int       nchan;
      int       reserved[5];
      PID       channel[1];
} PIDHEADER;

#define PID_MAGIC	0xCAFEBABE
#define PID_VERSION	0x00000001

#endif

