#ifndef _FASTMATH_H_
#define _FASTMATH_H_

/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1991 by John E. Lloyd.				    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#if FASTMATH_ENABLED

#include "../h/protoDef.h"

#ifdef __cplusplus
extern "C"
{
#endif

float SIN PROTO((double));
float COS PROTO((double));
float ATAN2 PROTO((double,double));
void SINCOS PROTO((double,float*,float*));
float SQRT PROTO((double));

#ifdef __cplusplus
}
#endif

#else

#include <math.h>

#define ATAN2(y,x)	atan2(y,x)
#define SINCOS(a, s, c) { *(s) = sin(a); *(c) = cos(a); }
#define COS(x)		cos(x)
#define SIN(x)		sin(x)
#define SQRT(x)		sqrt(x)

#endif

#endif
