#ifndef _S16DDRIVER_H_
#define _S16DDRIVER_H_

#include "s16dreg.h"

#ifdef __cplusplus
extern "C"
{
#endif

#define S16D_SIGOUT		S16D_FNCT2
#define S16D_SIGOUT_R	 	S16D_FNCT2_S
#define S16D_SIGIN		S16D_STATB_S
#define S16D_INTR_SET		S16D_FNCT1
#define S16D_INTR_GET		S16D_FNCT1_S
#define S16D_LISTEN		0x1234
#define S16D_READ_READY		0x1111
#define S16D_WRITE_READY	0x2222
#define S16D_SIGNAL_ACK		0x3333

#define S16D_DEFAULT_BLOCKTIME	100	/* 100 milliseconds */

extern s16dRead();
extern s16dTestRead();
extern s16dWrite();
extern s16dTestWrite();

extern s16dProbe();
extern s16dAttach();
extern s16dDetach();
extern s16dSignal();
extern s16dIoctl();

#ifdef __cplusplus
}
#endif

#endif
