#ifndef _SIGNALFXNS_H_
#define _SIGNALFXNS_H_

#include <signal.h>
#include "../h/protoDef.h"

#ifdef Qnx_TARGET
#include <unix.h>
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef HAS_BSD_SIGNALS
typedef	int SigSet;
#else
#ifdef HAS_POSIX_SIGNALS
typedef sigset_t SigSet;
#else
typedef	int SigSet;
#endif
#endif

#define SIGNAL_ERR ((SIGHAN_RETURN (*)())-1)

SIGHAN_RETURN (*signalCatch PROTO((int, SIGHAN_RETURN (*)())))();
SigSet signalMaskSet PROTO((SigSet));
SigSet signalMaskGet PROTO(());
SigSet signalMaskAdd PROTO((SigSet));
SigSet signalMaskDel PROTO((SigSet));
SigSet signalMaskAll PROTO(());

SigSet sigsetClear PROTO(());
SigSet sigsetAdd PROTO((SigSet, int));
SigSet sigsetDel PROTO((SigSet, int));
SigSet sigsetFill PROTO(());
SigSet sigsetInit PROTO((int));
int sigsetHasSig PROTO((SigSet, int));

#ifdef __cplusplus
}
#endif

#endif
