#ifndef _TERMLINE_H_
#define _TERMLINE_H_

/* A set of routines to provide some simple system-independent control
   over terminal input lines */

#include "../h/protoDef.h"

#ifdef HAS_TERMIOS
# include <termios.h>
#else
#ifdef HAS_TERMIO
# include <termio.h>
#else
#ifdef HAS_SGTTY
# include <sgtty.h>
#else
#ifdef Vxw_TARGET
# include <vxWorks.h> 
# include <stdioLib.h>
# include <ioLib.h>
#endif
#endif
#endif
#endif

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct {
#ifdef HAS_TERMIOS
	struct termios data;
#else
#ifdef HAS_TERMIO
	struct termio data;
#else
#ifdef HAS_SGTTY
	struct sgtty data;
#else
#ifdef Vxw_TARGET
	int data;
#else
	int data;
#endif
#endif
#endif
#endif
} TermProps;

int termlineGet PROTO((int, TermProps*));
int termlineSet PROTO((int, TermProps*));
int termlineRawMode PROTO((TermProps*));
int termlineCbreakMode PROTO((TermProps*));
int termlineEchoOff PROTO((TermProps*));
int termlineSpeed PROTO((TermProps*, int));
int termlineGetSpeed PROTO((TermProps*));

#ifdef __cplusplus
}
#endif

#endif
