#include "../h/cdefs.h"
#include <stdio.h>

#define YES 1
#define NO  0

char **argvec;

main(argc, argv)
int argc;
char **argv;
{
	FILE *hp;
	FILE *cp;
	int k;

	char *target = NULL;
	long nAuxCpus = 0;
	unsigned long busBase = 0;
	unsigned long IOPageBase = 0;
	long hexptSize = 0;
	long aexptSize = 0;
	char *checkPtr;

	argvec = argv;

	if (argc < 3)
	 { goto usage;
	 }
	if ((hp = fopen(argv[1],"w")) == NULL)
	 { fprintf (stderr, "Error: cannot open h-configFile %s\n", argv[1]);
	   exit (1);
	 }
	if ((cp = fopen(argv[2],"w")) == NULL)
	 { fprintf (stderr, "Error: cannot open c-configFile %s\n", argv[2]);
	   exit (1);
	 }
	argc -= 3;
	argv += 3;
	while (argc)
	 { if (argc < 2)
	    { goto usage;
	    }
	   if (ARGUMENT("-target"))
	    { target = argv[1];
	    }
	   else
	    { if (ARGUMENT("-nAuxCpus"))
	       { nAuxCpus = strtol(argv[1], &checkPtr, 0);
	       }
	      else if (ARGUMENT("-busBase"))
	       { busBase = strtol(argv[1], &checkPtr, 0);
	       }
	      else if (ARGUMENT("-IOPageBase"))
	       { IOPageBase = strtol(argv[1], &checkPtr, 0);
	       }
	      else if (ARGUMENT("-hexptSize"))
	       { hexptSize = strtol(argv[1], &checkPtr, 0);
	       }
	      else if (ARGUMENT("-aexptSize"))
	       { aexptSize = strtol(argv[1], &checkPtr, 0);
	       }
	      else
	       { goto usage;
	       }
	      if (argv[1] == checkPtr)
	       { fprintf (stderr, "%s: bad argument value\n", argvec[0]);
		 exit (1);
	       }
	    }
	   argc-=2; argv+=2;
	   continue;
usage:
	   fprintf (stderr, 
"Usage: %s <h-configFile> <c-configFile> [-target <str>] \n\
	[-nAuxCpus <val>] [-busBase <val>] [-IOPageBase <val>] \n\
	[-hexptSize <val>] [-aexptSize <val>]\n", argvec[0]);
	   exit (1);
	   printf ("returned from exit\n");
	 }
		
	fprintf(hp, "#ifndef _RCICONFIG_H_\n");
	fprintf(hp, "#define _RCICONFIG_H_\n");

	fprintf(hp, "\n");

	fprintf(hp, "/* target system %s */\n", target);
	fprintf(hp, "\n");

	fprintf(hp, "#define ARBITER_CPU       0\n");
	fprintf(hp, "#define ARBITER_MASK      (1<<ARBITER_CPU)\n");
	fprintf(hp, "#define AUXILIARY_MASK    (~ARBITER_MASK)\n");
	fprintf(hp, "#define NUM_AUX_CPUS      %d\n", nAuxCpus);
	fprintf(hp, "#define MAX_CPUS          %d\n", nAuxCpus+1);
	fprintf(hp, "\n");
	fprintf(hp, "#define HOST_BUS_BASE     0x%x\n", busBase);
	fprintf(hp, "#define HOST_IOPAGE_BASE  0x%x\n", IOPageBase);
	fprintf(hp, "\n");

	fprintf(hp, "\n");
	fprintf(hp, "#endif /*_RCICONFIG_H_*/\n");
	fclose(hp);	/* that's it for the h config file */

	fprintf(cp, "#include \"rciConfig.h\"\n");
	fprintf(cp, "\n");

	fprintf(cp, "int cpuExportSizes[MAX_CPUS] = {\n");
	fprintf(cp, "\t0x%x,\n", hexptSize);
	for (k=0; k<nAuxCpus; k++)
	 { fprintf(cp, "\t0x%x,\n", aexptSize); 
	 }
	fprintf(cp, "};\n");

	exit(0);
}
