#ifndef _CREATE_H_
#define _CREATE_H_

/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1991 by John E. Lloyd.				    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

/*---------------------------------------------------------------------------
 *
 * DESCRIPTION:	Private defintions used by the task creation and
 *		management code.
 * 
 * AUTHOR/DATE:	John Lloyd, Fall 1987
 *
 * MODIFICATION HISTORY:
 *
 *--------------------------------------------------------------------------*/

/* PRIVATE to auxMonitor.c, auxShare.c, create.c, loadtask.c, monitor.c */

#include "../h/cdefs.h"
#include "../h/robot_jls.h"
#include "../h/robotComfxns.h"
#include "../h/rciTask.h"

typedef struct {
	int flags;
	int taskID;
	int robotID;
	int cpu;
	void *shareMem;
	void *localMem;
	JLS *jls;
	KYN *kyn;
	int kynSize;
	int varSize;
	char name[TASK_NAME_SIZE+1];
} TASK_SPEC;

#define MAX_KYNSIZE	2048	/* maximum size of the kyn structure */

#endif
