/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd.			    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#include <stdio.h>
#include "../h/stringDefs.h"

#include "../h/cdefs.h"
#include "../h/robotComfxns.h"
#include "../h/errorCodes.h"
#include "../h/errorStack.h"

#include "robotData.h"

/* ----- Error Messages. Defined externally to save space ----- */

static char *rbtNotDefMsg	= "%s -- rbt %s: not defined in RCI tables\n";

find_robot (name)
const char *name;
{
	register ROBOT_DATA_ENTRY *rde;
	register int i;

	for (rde=rciRobotDataTable,i=1; rde->name; rde++,i++)
	 { if (strcmp (name, rde->name) == 0)
	    { return (i);
	    }
	 }
 	return (0);
}

robot_class(name)
const char *name;
{
	register ROBOT_DATA_ENTRY *rde;

	for (rde=rciRobotDataTable; rde->name; rde++)
	 { if (strcmp (name, rde->name) == 0)
	    { return (rde->rbtclass);
	    }
	 }
 	return (0);
}

get_comfxns (fxns, name)
ROBOT_COMFXNS *fxns;
char *name;
{
	register ROBOT_DATA_ENTRY *rde;

	for (rde=rciRobotDataTable; rde->name; rde++)
	 { if (strcmp (name, rde->name) == 0)
	    { fxns->startup = rde->startupFxn;
	      fxns->input =   rde->inputFxn;
	      fxns->output =  rde->outputFxn;
	      fxns->release = rde->releaseFxn;
	      return (1);
	    }
	 }
	return (0);
}

int getVarSize (name)
const char *name;
{
	char *fxnName = "getVarSize()";
	register ROBOT_DATA_ENTRY *rde;

	for (rde=rciRobotDataTable; rde->name; rde++)
	 { if (strcmp (name, rde->name) == 0)
	    { return (rde->varSize);
	    }
	 }
	errorMsg (ENotDefined, rbtNotDefMsg, fxnName, name);
	return (-1);
}

