/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd.			    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#ifndef _ROBOTDATA_H_
#define _ROBOTDATA_H_

/* PRIVATE to robotData.c and getRobotData.c */

#include "../h/cdefs.h"
#include "../h/robot_jls.h"

typedef struct {
	char *name;
  	int rbtclass;
	int (*getJls)();
	int (*getKyn)();
	int kynSize;
	int varSize;
	int (*startupFxn)();
	int (*inputFxn)();
	int (*outputFxn)();
	int (*releaseFxn)();
} ROBOT_DATA_ENTRY;

typedef struct {
	JLS *jls;
	KYN *kyn;
} ROBOT_DATA_PTRS;

extern ROBOT_DATA_ENTRY rciRobotDataTable[];
extern ROBOT_DATA_PTRS *rciRobotDataPtrs;
extern int rciRobotDataTableSize;

extern char *rbtGetNameOfClass();
extern char *rbtGetNameOfType();

#endif
