/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd and Vincent Hayward.	    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

/*---------McGill-Computer-Vision-and-Robotics-Laboratory--C-Module---------
 *		
 * NAME:	armkine.c
 *
 * DESCRIPTION: Definitions of several "read only" global data structures
 *		describing various kinematic constants of the robot.
 *
 *		THIS FILE IS ON IT'S WAY OUT. THE MAIN REASON FOR HAVING
 *		THESE GLOBAL VARIABLES HAS BEEN MADE OBSOLETE BY THE
 *		INTRODUCTION OF -F OPTIONS ON NEWER C COMPILERS.
 * 
 * GLOBAL VARS: armk_c, jready_c, j_minc, jrng_c, jmxv_c;
 *
 * NOTES:	One main reason for having these definitions available is
 *		that they are then stored and accessed as floats, instead
 *		of doubles, which speeds up the routines using them.
 *
 * AUTHOR/DATE: Vincient Hayward, Purdue University, 1983. Editted by
 *		John Lloyd at various times since then.
 *
 * UPDATES:
 *
 *-------------McGill-Computer-Vision-and-Robotics-Laboratory--------------*/

#include "rccl.h"
#include "kine.h"

#include "pumadata.h"
#include "pumaforce.h"

/* Calibration angles			*/

JNTS    jcal_c = {"      ", JCAL1, JCAL2, JCAL3, JCAL4, JCAL5, JCAL6};

/* Angles -> range offsets		*/

JNTS    jmin_c = {"      ", JMIN1, JMIN2, JMIN3, JMIN4, JMIN5, JMIN6};

/* Joint ranges				*/

JNTS    jrng_c = {"      ", JRNG1, JRNG2, JRNG3, JRNG4, JRNG5, JRNG6};

/*
 * 	Kinematics constants
 */

KINDYN  armk_c = {
		A2,             /* A2                           */
		D3,             /* D3                           */
		D4,             /* D4                           */
		D32,            /* D3 * D3                      */
		E42,            /* D4 * D4 + A2 * A2            */
		E4AD,           /* 4. * A2 * A2 * D4 * D4       */
		CP20,           /* joint gravity loading        */
		CP21,		/*  coefficients		*/
		CP30,
		CP50
		};
