/*=-=-=-=-=-=-=-=-=-=-  RCCL/RCI Notice of Copyright  -=-=-=-=-=-=-=-=-=-=-=*
 *									    *
 *	Copyright (C) 1987 by all authors described below. Permission to    *
 *	use, distribute and copy is granted, but only for non-commercial    *
 *	purposes and providing the authors are acknowledged and this 	    *
 *	copyright notice is displayed prominently.			    *
 *									    *
 *	The authors provide this software in hope that it will be useful,   *
 *	but do not assume responsibility for its use.			    *
 *									    *
 *=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/

/*----------McGill-Computer-Vision-and-Robotics-Laboratory--C-File-----------
 *
 * FILE NAME:	convert.h
 *
 * DESCRIPTION: Include file defining constants and enumerated types
 *		for various user level IO routines. Principally a
 *		part of RCI (Real Time Control) library, but used also
 *		by RCCL.
 *
 * AUTHOR:	John Lloyd, CVaRL, January, 1985.
 *
 * NOTES:
 *
 *-------------McGill-Computer-Vision-and-Robotics-Laboratory--------------*/

#ifndef CONVERTH
#define CONVERTH

#ifndef PI
#define PI        3.14159265358979320
#define PIT2      6.28318530717958650	  /* pi * 2 */
#define PIB2      1.57079632679489660     /* pi / 2 */
#define RADTODEG 57.29577951308232100
#define DEGTORAD  0.01745329251994330
#endif

typedef enum {
	  None,
	  Degree_to_radian,
	  Degree_to_range,
	  Radian_to_degree,
	  Radian_to_range,
	  Range_to_degree,
	  Range_to_radian
	     } CONVERT_CODE;

#define INCLUSIVE	0
#define EXCLUSIVE	1
#define BADCODE		-10

#endif
