/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd.			    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/

#include <stdio.h>
#include <math.h>

#include "../h/cdefs.h"
#include "../h/robotClass.h"
#include "../h/stage_kynvar.h"
#include "../h/errorCodes.h"
#include "../h/errorStack.h"
#include "../h/robotMath.h"

#define EPSILONF 	1.0e-7

stage_kyn (kyn, fp)
KYN *kyn;
FILE *fp;
{
	STAGE_KYN *skyn = (STAGE_KYN*)kyn->ext;
	ConfCodeDesc *desc;

	char *fxnName = "stage_kyn()";

	readInit(fp,"=");
	if (gen_readNomVelAcc (fxnName, kyn->gen) == -1)
	 { return (-1);
	 }

	kyn->gen->dh[0].alpha = -PI/2;
	kyn->gen->dh[1].alpha =  PI/2;
	kyn->gen->dh[1].theta = -PI/2;

	/* ---- Configuration codes ---- */
	kyn->gen->numConf = 1;
	
	/* ---- Instantiate function fields ---- */

	kyn->gen->fwdKinematics = stageFwdKinematics;
	kyn->gen->invKinematics = stageInvKinematics;
	kyn->gen->rangeAngles = stageRangeAngles;
	kyn->gen->solveConf = stageSolveConf;
	kyn->gen->fwdJacob = stageFwdJacob;
	kyn->gen->invJacob = stageInvJacob;
	kyn->gen->fwdJacobT = stageFwdJacobT;
	kyn->gen->invJacobT = stageInvJacobT;
	kyn->gen->gravload = stageGravload;
	kyn->gen->fwdJacobVar = stageFwdJacobVar;
	kyn->gen->invJacobVar = stageInvJacobVar;
	kyn->gen->fwdJacobTVar = stageFwdJacobTVar;
	kyn->gen->invJacobTVar = stageInvJacobTVar;
	kyn->gen->gravloadVar = stageGravloadVar;
	kyn->gen->updateVar = stageUpdateVar;
	kyn->gen->updateVarXsincos = stageUpdateVarXsincos;

	kyn->gen->rbtclass = STAGE;

	return (1);
}
