/* 
 * gripper.h -- 
 * 
 * Stewart Kingdon,
 * Copyright (c) 1994,
 * Laboratory for Computational Intelligence,
 * University of British Columbia.
 */

#ifndef _GRIPPER_INCLUDED_
#define _GRIPPER_INCLUDED_

#ifdef T212
typedef struct { int lo, hi; }	INT32;
#else
typedef int			INT32;
#endif

enum { GRIPPER_NOOP,
       GRIPPER_POSN,
       GRIPPER_FORCE,
       GRIPPER_COEF };

typedef struct {
    INT32   type;
    union {
	INT32	posn;
	INT32	force;
	struct {
	    unsigned char   max_err;
	    unsigned char   max_sumerr;
	    unsigned char   period_10us;
	} coef;
    } gripper;
} GRIP_REQ;

typedef struct {
    INT32   status;
    INT32   gripper_posn;
    INT32   gripper_torque;
    INT32   force_feedback[6];
} GRIP_REP;

#endif
