#ifdef Tsp_TARGET         

#include <stdio.h>
#include <cdefs.h>        
#include <conc.h>
#include "tgen.h"
#include "servo.h"
#include <vector.h>
#include <puma_kynvar.h>

#define SEC_TO_TICKS    (1000000/64.)

main()
{
	JntVec jc;
	TRSF TC, TH;
	Tgen *tg;

	printf ("Allocating trajectory generator ...\n");

	if ((tg = tgenAlloc ("caesar")) == NULL)
	 { printErrors ();
	   exit (1);
	 }
	printf ("done\n");

	tgenSetCartVel (tg, 200.0, -1);
	tgenSetCartAcc (tg, 1000.0, -1);

	printf ("Starting trajectory generator ...\n");
	if (tgenStart (tg, 0.01, LINK3OUT, LINK3IN, LINK2OUT, LINK2IN) < 0)
	 { printErrors();
	   exit (1);
	 }
	printf ("done\n");

	if (getRobotPosition (jc.v, "demohome", "caesar") < 0)
	 { printErrors();
	   exit (1);
	 }
	printf ("moving to demohome (confirm):\n");
	while (getchar() != '\n')
	   ;
	tgenMoveJ (tg, &jc);

	do
	 { ProcWait (0.2*SEC_TO_TICKS);
	 }
	while (tgenIsBusy(tg));

	tgenRelease (tg);

	printf ("released\n");
}

#endif
