/*-=-=-=-=-=-=-=-=-=-=-=- RCCL/RCI Notice of Copyright -=-=-=-=-=-=-=-=-=-=-*
 *									    *
 *	Copyright (C) 1987, 1991 by John E. Lloyd.			    *
 *									    *
 *	Information on copyright permissions, as well as a complete	    *
 *	disclaimer of warranty, is given in the file COPYRIGHT.		    *
 *									    *
 *-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
/* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

		Routines to do adjustment of output


   -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */

#include <stdio.h>
#include "../h/varargInc.h"
#include "../h/cdefs.h"
#include "../h/printc.h"
#include "../h/snprintf.h"

printc VA_ARGDEF((int n, char* fmt, ...))
{
	va_list ap;
	int status;
#if !USE_STDARG
	int n;
	char *fmt;

	va_start(ap);
	n = va_arg(ap, int);
	fmt = va_arg(ap, char*);
#else
	va_start(ap,fmt);
#endif
	status = vfprintc (stdout, n, fmt, ap);
	va_end(ap);
	return (status);
}

fprintc VA_ARGDEF((FILE *fp, int n, char* fmt, ...))
{
	va_list ap;
	int status;
#if !USE_STDARG
	FILE *fp;
	int n;
	char *fmt;

	va_start(ap);
	fp = va_arg(ap, FILE*);
	n = va_arg(ap, int);
	fmt = va_arg(ap, char*);
#else
	va_start(ap,fmt);
#endif
	status = vfprintc (fp, n, fmt, ap);
	va_end(ap);
	return (status);
}

#define OBUFSIZE	256

#define PUTC(c,f)	if (putc (c,f) == EOF) return -1; else nc++;

int vfprintc (fp, n, fmt, ap)
FILE *fp;
int n;
char *fmt;
va_list ap;
{
	char buf[OBUFSIZE+1];
	char *cp;
	int k, diff;
	int nc = 0;
	
	vsnprintf (buf, OBUFSIZE, fmt, ap);
	if ((diff = ABS(n) - strlen(buf)) > 0)
	 { if (n < 0)
	    { for (cp = buf; *cp != '\0'; cp++)
	       { PUTC (*cp, fp);
	       }
	      for (k=0; k<diff; k++)
	       { PUTC (' ', fp);
	       }
	    }
	   else
	    { for (k=0; k<diff; k++)
	       { PUTC (' ', fp);
	       }
	      for (cp = buf; *cp != '\0'; cp++)
	       { PUTC (*cp, fp);
	       }
	    }	      
	 }
	return (nc);
}
