#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <rciioctl.h>
#include <xyclkreg.h>
#include <sys/mman.h>

char *devname = "/dev/xyclk0";

union pack {
	unsigned char c[2];
	unsigned short s;
  };
	
/* Macros for sending commands. Assumes 'regs' and 'pack' defined */
#define COMMAND_A(c)	(regs->cntrA_com = (c))
#define WRITE_A(d)	(pack.s = (d), 			\
			 regs->cntrA_data = pack.c[1], \
			 regs->cntrA_data = pack.c[0])
#define READ_A(d)	(pack.c[1] = regs->cntrA_data,	\
			 pack.c[0] = regs->cntrA_data,	\
			 (d) = pack.s)
#define COMMAND_B(c)	(regs->cntrB_com = (c))
#define WRITE_B(d)	(pack.s = (d), 			\
			 regs->cntrB_data = pack.c[1], \
			 regs->cntrB_data = pack.c[0])
#define READ_B(d)	(pack.c[1] = regs->cntrB_data,	\
			 pack.c[0] = regs->cntrB_data,	\
			 (d) = pack.s)
#define COMMAND_I(c)	(regs->uic_com = (c))
#define WRITE_I(d)	(regs->uic_data = (d))
#define READ_I(d)	((d) = regs->uic_data)

printRegs (caddr_t regaddr)
{
	union pack pack;
	unsigned short count;

	XyclkRegs *regs = (XyclkRegs*)regaddr;

	printf ("status=0x%x\n", regs->csr);

	COMMAND_A (LOAD_PTR | HOLD_REG | CNTR3);
	COMMAND_A (SAVE | 0x4);
	READ_A (count);

	printf ("count=%d\n", count);
}

main()
{
	int fd;
	caddr_t regs;

	if ((fd = open(devname, O_RDWR)) == -1)
	 { perror ("open");
	   exit (1);
	 }
	regs = mmap((caddr_t)0, sizeof(XyclkRegs), PROT_READ|PROT_WRITE,
			   MAP_SHARED, fd, 0);
	if (regs == (caddr_t)(-1))
	 { perror ("mmap");
	   exit (1);
	 }
	
	while (1)
	 { while (getchar() != '\n')
	      ;
	   printRegs (regs);
	 }
}
