#ifndef _XYDREG_H_
#define _XYDREG_H_

#include "rcisys.h"
#include <sys/poll.h>

typedef struct {
  unsigned char id[0x40];
  unsigned char unused1[0x40];
  volatile unsigned char intin;
  volatile unsigned char csr;
#define XYD_RED       0x01
#define XYD_RED_ON    0x00
#define XYD_RED_OFF   0x01
#define XYD_GREEN     0x02
#define XYD_GREEN_ON  0x02
#define XYD_GREEN_OFF 0x00
#define XYD_INTPEND   0x04
#define XYD_INTENB    0x08
#define XYD_RESET     0x10
#define XYD_USER      0xe0
  volatile unsigned char intpend;
  volatile unsigned char intmask;
  volatile unsigned char intclear;
  volatile unsigned char vector;
  volatile unsigned char out;
  volatile unsigned char dirs;
  volatile unsigned char ports[8];
  unsigned char unused2[0x370];
  } XydRegs;

/* control masks and codes */
#define XYD_DIRMASK	0xf2
#define XYD_INTRMASK	0x01
#define XYD_INTRCLEAR   0xff

typedef struct {
	dev_info_t *dip;
	int instance;
	int hasHighLevelIntr;
	/*volatile*/ struct pollhead pollhead;

	ddi_iblock_cookie_t iblkCookie;
	ddi_idevice_cookie_t idevCookie;
	kmutex_t intrMux;

	/* fields for low-level interrupt handler, if needed */
	ddi_iblock_cookie_t softIblkCookie;
	kmutex_t lowMux;
	int softIntrRunning;
	ddi_softintr_t softIntrId;
	int stray;

	kmutex_t *muxp;

#define XYD_INTR_MUTEX_SET	0x01
#define XYD_LOW_MUTEX_SET	0x02
#define XYD_IHANDLER_SET	0x04
#define XYD_SOFT_IHANDLER_SET	0x08
#define XYD_REGS_MAPPED		0x10
#define XYD_MAIN_MINOR_CREATED  0x20
#define XYD_MMAP_MINOR_CREATED  0x40
	int resources;

	volatile int highIntrCnt;
	volatile int intrCnt;
	volatile int qsize;
#define XYD_BUSY	0x01
	volatile int flags;
	XydRegs *regs;
} XydSoftc;

#endif
