#ifndef _ATIREG_H_
#define _ATIREG_H_

#ifdef KERNEL
#include "sys/poll.h"
#else
#include <sys/poll.h>
#endif

#include "atiioctl.h"
#include <sys/segment.h>	/* for ATIIOC_ENABLE_IOPORTS */
#include <enableIO.h>

/* For memory mapped access: */

typedef struct {
	volatile unsigned short addr;		/* 00 */
	volatile unsigned short data;		/* 02 */
	volatile unsigned short status;		/* 04 */
  } AtiRegs;

/* For I/O port access: */

#define ATI_addr	0x00
#define ATI_data	0x02
#define ATI_status	0x04

/* ATI interface commands */

#define ATI_SENSOR_DATA_CMD	0x100
#define ATI_CARD_DATA_CMD	0x200
#define ATI_BIAS_ARRAY_CMD	0x300
#define ATI_GET_PEAK_CMD	0x400
#define ATI_RESET_CMD		0x500
#define ATI_CALMATRIX_CMD	0x600
#define ATI_MONITOR_CMD		0x700
#define ATI_DISCRETE_IO_CMD	0x800

/* ATI interface modes */

#define ATI_READ		0
#define ATI_WRITE		1
#define ATI_NO_MODE		-1

#define ATI_DEFAULT_FBUF_SIZE	1000 /* default # recs in force data buffer */

#ifdef _KERNEL

typedef struct {
	dev_info_t *dip;
	int instance;
	int hasHighLevelIntr;

	ddi_iblock_cookie_t iblkCookie;
	ddi_idevice_cookie_t idevCookie;
	ddi_acc_handle_t regsHandle;
	kmutex_t intrMux;

	/* fields for low-level interrupt handler, if needed */
	ddi_iblock_cookie_t softIblkCookie;
	kmutex_t lowMux;
	int softIntrRunning;
	ddi_softintr_t softIntrId;
	int stray;

	kmutex_t *muxp;

#define ATI_INTR_MUTEX_SET	0x01
#define ATI_LOW_MUTEX_SET	0x02
#define ATI_IHANDLER_SET	0x04
#define ATI_SOFT_IHANDLER_SET	0x08
#define ATI_REGS_MAPPED		0x10
#define ATI_MAIN_MINOR_CREATED  0x20
	int resources;

	volatile int highIntrCnt;
	volatile int intrCnt;
	volatile int qsize;
	/*volatile*/ struct pollhead pollhead;
#define ATI_OPEN	0x01
#define ATI_CAPTURE_ON	0x02
	volatile int flags;
	AtiRegs *regs;
	int iobase;

	AtiForceRec *fbuf;
	AtiCardDataRec cdata;
	volatile int fhead;
	volatile int ftail;
	int fsize;
	int foverflow;

	EnioRec enio;	/* for ATIIOC_ENABLE_IOPORTS */
} AtiSoftc;

#endif

#endif
